define(["require","exports","../utils/api","../utils/async","../utils/dispose","../utils/languageModeIds","../utils/resourceMap","../utils/typeConverters","vs/ex/helper/vs"],(function(e,t,s,i,n,r,o,a,c){"use strict";var h,l;Object.defineProperty(t,"__esModule",{value:!0}),function(e){e[e.TypeScript=1]="TypeScript",e[e.JavaScript=2]="JavaScript"}(h||(h={})),function(e){e[e.Initial=1]="Initial",e[e.Open=2]="Open",e[e.Closed=2]="Closed"}(l||(l={}));class u{constructor(e){this.client=e,this._pending={},this._pendingFiles=new Set}open(e){this.supportsBatching?this.updatePending(e.file,(t=>{t.openFiles||(t.openFiles=[]),t.openFiles.push(e)})):this.client.executeWithoutWaitingForResponse("open",e)}close(e){if(this.supportsBatching)this.updatePending(e,(t=>{t.closedFiles||(t.closedFiles=[]),t.closedFiles.push(e)}));else{const t={file:e};this.client.executeWithoutWaitingForResponse("close",t)}}change(e,t){if(t.length)if(this.supportsBatching)this.updatePending(e,(s=>{s.changedFiles||(s.changedFiles=[]),s.changedFiles.push({fileName:e,textChanges:t.map((e=>({newText:e.text,start:a.Position.toLocation(e.range.start),end:a.Position.toLocation(e.range.end)}))).reverse()})}));else for(const{range:s,text:i}of t){const t=Object.assign({insertString:i},a.Range.toFormattingRequestArgs(e,s));this.client.executeWithoutWaitingForResponse("change",t)}}beforeCommand(e){"updateOpen"!==e&&this.flush()}flush(){this.supportsBatching&&(this._pending.changedFiles||this._pending.closedFiles||this._pending.openFiles)&&(this.client.executeWithoutWaitingForResponse("updateOpen",this._pending),this._pending={},this._pendingFiles.clear())}get supportsBatching(){return this.client.apiVersion.gte(s.default.v340)&&c.vs.workspace.getConfiguration("typescript",null).get("useBatchedBufferSync",!0)}updatePending(e,t){this.supportsBatching&&this._pendingFiles.has(e)?(this.flush(),this._pendingFiles.clear(),t(this._pending),this._pendingFiles.add(e)):t(this._pending)}}class d{constructor(e,t,s,i){this.document=e,this.filepath=t,this.client=s,this.synchronizer=i,this.state=1}open(){const e={file:this.filepath,fileContent:this.document.getText()};if(this.client.apiVersion.gte(s.default.v203)){const t=function(e){switch(e){case r.typescript:return"TS";case r.typescriptreact:return"TSX";case r.javascript:return"JS";case r.javascriptreact:return"JSX"}}(this.document.languageId);t&&(e.scriptKindName=t)}if(this.client.apiVersion.gte(s.default.v230)&&(e.projectRootPath=this.client.getWorkspaceRootForResource(this.document.uri)),this.client.apiVersion.gte(s.default.v240)){const t=this.client.pluginManager.plugins.filter((e=>e.languages.indexOf(this.document.languageId)>=0));t.length&&(e.plugins=t.map((e=>e.name)))}this.synchronizer.open(e),this.state=2}get resource(){return this.document.uri}get lineCount(){return this.document.lineCount}get kind(){switch(this.document.languageId){case r.javascript:case r.javascriptreact:return 2;case r.typescript:case r.typescriptreact:default:return 1}}close(){this.synchronizer.close(this.filepath),this.state=2}onContentChanged(e){2!==this.state&&console.error(`Unexpected buffer state: ${this.state}`),this.synchronizer.change(this.filepath,e)}}class g extends o.ResourceMap{getForPath(e){return this.get(c.vs.Uri.file(e))}get allBuffers(){return this.values}}class p extends o.ResourceMap{getOrderedFileSet(){const e=Array.from(this.entries).sort(((e,t)=>e.value-t.value)).map((e=>e.resource)),t=new o.ResourceMap;for(const s of e)t.set(s,void 0);return t}}class f{constructor(e,t,s,i){this.files=t,this._token=s,this._done=!1;const n={delay:0,files:Array.from(t.entries).map((t=>e.normalizedPath(t.resource))).filter((e=>!!e))};e.executeAsync("geterr",n,s.token).finally((()=>{this._done||(this._done=!0,i())}))}static executeGetErrRequest(e,t,s){const i=new c.vs.CancellationTokenSource;return new f(e,t,i,s)}cancel(){this._done||this._token.cancel(),this._token.dispose()}}class D extends n.Disposable{constructor(e,t){super(),this._validateJavaScript=!0,this._validateTypeScript=!0,this.listening=!1,this._onDelete=this._register(new c.vs.EventEmitter),this.onDelete=this._onDelete.event,this.client=e,this.modeIds=new Set(t),this.diagnosticDelayer=new i.Delayer(300);const s=e=>this.client.normalizedPath(e);this.syncedBuffers=new g(s),this.pendingDiagnostics=new p(s),this.synchronizer=new u(e),this.updateConfiguration(),c.vs.workspace.onDidChangeConfiguration(this.updateConfiguration,this,this._disposables)}listen(){this.listening||(this.listening=!0,c.vs.workspace.onDidOpenTextDocument(this.openTextDocument,this,this._disposables),c.vs.workspace.onDidCloseTextDocument(this.onDidCloseTextDocument,this,this._disposables),c.vs.workspace.onDidChangeTextDocument(this.onDidChangeTextDocument,this,this._disposables),c.vs.workspace.textDocuments.forEach(this.openTextDocument,this))}handles(e){return this.syncedBuffers.has(e)}toResource(e){const t=this.syncedBuffers.getForPath(e);return t?t.resource:c.vs.Uri.file(e)}reOpenDocuments(){for(const e of this.syncedBuffers.allBuffers)e.open()}openTextDocument(e){if(!this.modeIds.has(e.languageId))return;const t=e.uri,s=this.client.normalizedPath(t);if(!s)return;if(this.syncedBuffers.has(t))return;const i=new d(e,s,this.client,this.synchronizer);this.syncedBuffers.set(t,i),i.open(),this.requestDiagnostic(i)}closeResource(e){const t=this.syncedBuffers.get(e);t&&(this.pendingDiagnostics.delete(e),this.syncedBuffers.delete(e),t.close(),this._onDelete.fire(e),this.requestAllDiagnostics())}interuptGetErr(e){if(!this.pendingGetErr)return e();this.pendingGetErr.cancel(),this.pendingGetErr=void 0;const t=e();return this.triggerDiagnostics(),t}beforeCommand(e){this.synchronizer.beforeCommand(e)}onDidCloseTextDocument(e){this.closeResource(e.uri)}onDidChangeTextDocument(e){const t=this.syncedBuffers.get(e.document.uri);if(!t)return;t.onContentChanged(e.contentChanges);!this.requestDiagnostic(t)&&this.pendingGetErr&&(this.pendingGetErr.cancel(),this.pendingGetErr=void 0,this.triggerDiagnostics())}requestAllDiagnostics(){for(const e of this.syncedBuffers.allBuffers)this.shouldValidate(e)&&this.pendingDiagnostics.set(e.resource,Date.now());this.triggerDiagnostics()}getErr(e){const t=e.filter((e=>this.handles(e)));if(t.length){for(const e of t)this.pendingDiagnostics.set(e,Date.now());this.triggerDiagnostics()}}triggerDiagnostics(e=200){this.diagnosticDelayer.trigger((()=>{this.sendPendingDiagnostics()}),e)}requestDiagnostic(e){if(!this.shouldValidate(e))return!1;this.pendingDiagnostics.set(e.resource,Date.now());const t=Math.min(Math.max(Math.ceil(e.lineCount/20),300),800);return this.triggerDiagnostics(t),!0}hasPendingDiagnostics(e){return this.pendingDiagnostics.has(e)}sendPendingDiagnostics(){const e=this.pendingDiagnostics.getOrderedFileSet();for(const t of this.syncedBuffers.values)e.set(t.resource,void 0);if(e.size){if(this.pendingGetErr){this.pendingGetErr.cancel();for(const t of this.pendingGetErr.files.entries)e.set(t.resource,void 0)}const t=this.pendingGetErr=f.executeGetErrRequest(this.client,e,(()=>{this.pendingGetErr===t&&(this.pendingGetErr=void 0)}))}this.pendingDiagnostics.clear()}updateConfiguration(){const e=c.vs.workspace.getConfiguration("javascript",null),t=c.vs.workspace.getConfiguration("typescript",null);this._validateJavaScript=e.get("validate.enable",!0),this._validateTypeScript=t.get("validate.enable",!0)}shouldValidate(e){switch(e.kind){case 2:return this._validateJavaScript;case 1:default:return this._validateTypeScript}}}t.default=D}));